#include "stack.h"

void init(Stack *s)
/* Initialise the stack, so it contains 0 elements. */
{
    s->p = s->buffer;
}

int push(Stack *s, const StackType *item) 
/* Push item onto stack. Return 0 if successful, -1 if stack full. */
{
    if (s->p == &s->buffer[MAXSIZE]) return -1;
    *s->p++ = *item;
    return 0;
}

int pop(Stack *s, StackType *item) 
/* Pop item off stack. Return 0 if successful, -1 if stack empty. */
{
    if (s->p == s->buffer) return -1;
    *item = *--s->p;
    return 0;
}
